out vec4 FragColor;
in vec2 TexCoord;
uniform sampler2D Texture;
//const float brightness = 0.5;

float ditherpattern(vec2 position, float brightness) {
  int x = int(mod(position.x, 2.0));
  int y = int(mod(position.y, 2.0));
  int index = x + y * 2;
  float limit = 0.0;

  if (x < 8) {
    if (index == 0) limit = 0.25;
    if (index == 1) limit = 0.75;
    if (index == 2) limit = 1.00;
    if (index == 3) limit = 0.50;
  }

	return brightness < limit ? 0.0 : 1.0;
}

float luma(vec3 color) {
  return dot(color, vec3(0.299, 0.587, 0.114));
}

float luma(vec4 color) {
  return dot(color.rgb, vec3(0.299, 0.587, 0.114));
}

vec3 dither8x8(vec2 position, vec3 color) {
  return color * ditherpattern(position, luma(color));
}

vec4 dither8x8(vec2 position, vec4 color) {
//  return vec4(color.rgb * ditherpattern(position, luma(color)), 1.0);
	return vec4(luma(color) * ditherpattern(position, luma(color)),luma(color) * ditherpattern(position, luma(color)),luma(color) * ditherpattern(position, luma(color)),1.0);
//	return vec4(1.0,1.0,0.0,1.0);
}

void main() {
  vec4 color = texture2D(Texture, TexCoord.xy);
  FragColor = dither8x8(TexCoord.xy, color);
}