//https://github.com/cabbibo/FallSketches/blob/master/fragment-shaders/denoise-fs.glsl
uniform sampler2D Texture;
uniform float strength;
uniform vec2 resolution;
in vec2 TexCoord;

void main() {

	vec4 center = texture2D(Texture, TexCoord);
	vec4 color = vec4(0.0);
	float total = 0.0;
	for (float x = -4.0; x <= 4.0; x += 1.0) {
		for (float y = -4.0; y <= 4.0; y += 1.0) {
			vec4 sample = texture2D(Texture, TexCoord + vec2(x, y) / vec2(1280,720));
			float weight = 1.0 - abs(dot(sample.rgb - center.rgb, vec3(0.25)));
			weight = pow(weight, 10);//, exponent
			color += sample * weight;
			total += weight;
		}
	}
	gl_FragColor = color / total;

}