//Modified from Christopher Lawless' code at https://github.com/lawlessc/oliveretroshader
out vec4 FragColor;
in vec2 TexCoord;
uniform sampler2D Texture;
precision lowp float;

varying lowp vec2 v_texCoord;
//pallete
lowp vec3 lighthest  = vec3(0.61,0.74,0.06);
lowp vec3 light      = vec3(0.55,0.67,0.06);
lowp vec3 dark       = vec3(0.19,0.38,0.19);
lowp vec3 darkest    = vec3(0.06,0.22,0.06);

void main() {
    float dx = 0.005859375;//3.0*(1./512.);
    float dy = 0.00390625; //2.0*(1./512.);
    vec2 coord = vec2(dx*floor(TexCoord.x/dx),
                      dy*floor(TexCoord.y/dy));
    vec4 col = texture2D(Texture, coord);

    float ave = (col.r + col.g +col.b)/3.0;
    vec3 fin;

    if(ave < 0.1){fin =darkest;}
    if(ave >= 0.1){fin =dark;}
    if(ave >= 0.30){fin =light;}
    if(ave >= 0.75){fin =lighthest;}

	gl_FragColor= vec4(fin,1.0);
}