//Modified from compsci89's post at http://irrlicht.sourceforge.net/forum/viewtopic.php?f=9&t=45531
//If you're not going to play in 16:9 then you'll need to adjust the X value, which is 480 right now.
//Formula to get the X is 240*(aspectwidth/aspectheight). Round up to the next nearest number.
//For example, 16:9 is 240*(16/9)=426.667. That's an ugly-ass number though so I round up to the next even number, 428.

out vec4 FragColor;
in vec2 TexCoord;
uniform sampler2D Texture;
//uniform float new_w, new_h, palette;

vec4 pixelate(sampler2D tex, vec2 uv)
{
vec2 coord = vec2( (ceil(uv.x * 480) / 480),//Replace 480 with your new X value.
ceil(uv.y * 200) / 200);
return texture2D(tex, coord);
}

vec4 reduce_palette(vec4 color, float max_colors_per_channel)
{
if(max_colors_per_channel < 0) {
return color;
}
   
return ceil(color * max_colors_per_channel) / max_colors_per_channel;
}
 
void main()
{
vec4 color = pixelate(Texture, TexCoord);
FragColor = reduce_palette(color, 20);//20 is the number of levels to posterize to. Lower crunches more, higher crunches less.
}