//http://www.geeks3d.com/20091027/shader-library-posterization-post-processing-effect-glsl/
//http://irrlicht.sourceforge.net/forum/viewtopic.php?f=9&t=45531
//If you're not going to play in 16:9 then you'll need to adjust the aspect ratio.

//Raising the gamma lowers the number of colours available for shadows.
//It's set to 0.46 right now because I figure it'll about linearize a 2.2 gamma image.
//Adjust the number of colours by altering the number in the lines commented with "The number of colors".

out vec4 FragColor;
in vec2 TexCoord;
uniform sampler2D Texture;

//https://github.com/AnalyticalGraphicsInc/cesium/blob/master/Source/Shaders/Builtin/Functions/saturation.glsl
vec4 czm_saturation(vec4 c, float adjustment)
{
    // Algorithm from Chapter 16 of OpenGL Shading Language
    const vec4 W = vec4(0.2125, 0.7154, 0.0721, 0.0);
    vec4 intensity = vec4(dot(c, W));
    return mix(intensity, c, adjustment);
}

vec4 pixelate(sampler2D tex, vec2 uv)
{
vec2 coord = vec2( (ceil(uv.x * (240*(16/9))) / (240*(16/9))),//Replace 16/9 with your aspect ratio.
ceil(uv.y * 200) / 200);
return texture2D(tex, coord);
}

void main() 
{
  vec4 c = pixelate(Texture, TexCoord);
//  vec3 c = texture2D(Texture, TexCoord.xy).rgb;
  c = pow(c, vec4(0.46, 0.46, 0.46, 1));//gamma, gamma, gamma
  c = c * 24;//The number of colors
  c = floor(c);
  c = c / 24;//The number of colors
  c = pow(c, vec4(1.0/0.46));//1.0/gamma
  FragColor = czm_saturation(c, 1.25);
}